<?php
namespace moonlight\eticket;
class eticket_agency_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Function to retrieve the list of agency
	 *
	 * @access public
	 * @return
	 */
	public function agency_list( $p_order=NULL, $p_start = NULL, $p_num_of_rec = NULL ){
		// Default Language
		$v_lang_info = \E::get('obj_curr_module')->get_lang();
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order !== NULL){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.\U::safe_sql_string( $v_value['order_by'] ).' '.\U::safe_sql_string( $v_value['sort_by'] );
				else $v_order_by .= ', ' . \U::safe_sql_string( $v_value['order_by'] ) . ' ' .\U::safe_sql_string( $v_value['sort_by'] );
			}
		}
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== NULL && $p_num_of_rec !== NULL){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
		}
		// QUERY - Coding
		$v_query = 	"SELECT 
						ag_id,
						ag_code,
						ag_name,
						case status when '0' then 'In-active' else 'Active' end as status
					FROM " . $this->get_db_table_prefix() . "agency 
					WHERE _rec_status = \"SHOW\" ";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Function to count total of agency
	 *
	 * @access public
	 * @return
	 */
	public function agency_list_total($p_condition=NULL){
		// Default Language
		$v_lang_info = \E::get('obj_curr_module')->get_lang();
		// QUERY - Coding
		$v_query = 	"SELECT 
						count (*) as total
					FROM " . $this->get_db_table_prefix() . "agency  " . $p_condition ;
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Add new agency
	 *
	 * @access public
	 * @return
	 */
	public function agency_save($p_data) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				$v_query = "INSERT INTO
						" . $this->get_db_table_prefix() . "agency 
					SET
						ag_name = '".\U::safe_sql_string($p_data['name'])."',
						ag_code = '".\U::safe_sql_string($p_data['code'])."',
						contact_no = '".\U::safe_sql_string($p_data['contact_no'])."',
						fax = '".\U::safe_sql_string($p_data['fax'])."',
						email = '".\U::safe_sql_string($p_data['email'])."',
						address = '".\U::safe_sql_string($p_data['address'])."',
						post_code = '".\U::safe_sql_string($p_data['post_code'])."',
						division = '".\U::safe_sql_string($p_data['division'])."',
						person_charge = '".\U::safe_sql_string($p_data['person_charge'])."',
						total_ticket_per_day = '".\U::safe_sql_string($p_data['total_ticket_per_day'])."',
						sarawak_pay_merchant = '".\U::safe_sql_string($p_data['sarawak_pay_merchant'])."',
						sarawak_pay_sifbas = '".\U::safe_sql_string($p_data['sarawak_pay_sifbas'])."',
						merchant_id = '".\U::safe_sql_string($p_data['merchant_id'])."',
						merchant_private_key = '".\U::safe_sql_string($p_data['merchant_private_key'])."',
						ptj_code = '".\U::safe_sql_string($p_data['ptj_code'])."',
						remarks = '".\U::safe_sql_string($p_data['remarks'])."',
						_rec_status = '".\U::safe_sql_string($p_data['_rec_status'])."',
						_rec_created_by = '".\U::safe_sql_string($p_data['_rec_created_by'])."',
						_rec_created_on = '".\U::safe_sql_string($p_data['_rec_created_on'])."',
						_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
						_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
					";
				$v_role_add = $this->co_db_root->execute_query($v_query);
				if ($v_role_add) {
					return $v_role_id = $this->co_db_root->get_last_insert_id();
				}
			}
		}
	}
	/**
	 * Retrieve agency by id
	 *
	 * @access public
	 * @return
	 */
	public function agency_get_by_id($p_location_id) {
		if( isset($p_location_id) ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "agency 
				 		WHERE
				 			ag_id = '".\U::safe_sql_string($p_location_id)."'
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			if( isset($v_locations_data[0]) ) {
				return $v_locations_data[0];
			}
		}
	}
	/**
	 * Update agency
	 *
	 * @access public
	 * @return
	 */
	public function agency_update($p_data, $p_id_to_update_table) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				if( isset($p_id_to_update_table) && $p_id_to_update_table != '' ) {
					$v_query = "UPDATE
							" . $this->get_db_table_prefix() . "agency 
						SET
							ag_name = '".\U::safe_sql_string($p_data['name'])."',
							ag_code = '".\U::safe_sql_string($p_data['code'])."',
							contact_no = '".\U::safe_sql_string($p_data['contact_no'])."',
							fax = '".\U::safe_sql_string($p_data['fax'])."',
							email = '".\U::safe_sql_string($p_data['email'])."',
							address = '".\U::safe_sql_string($p_data['address'])."',
							post_code = '".\U::safe_sql_string($p_data['post_code'])."',
							division = '".\U::safe_sql_string($p_data['division'])."',
							person_charge = '".\U::safe_sql_string($p_data['person_charge'])."',
							total_ticket_per_day = '".\U::safe_sql_string($p_data['total_ticket_per_day'])."',
							sarawak_pay_merchant = '".\U::safe_sql_string($p_data['sarawak_pay_merchant'])."',
							sarawak_pay_sifbas = '".\U::safe_sql_string($p_data['sarawak_pay_sifbas'])."',
							merchant_id = '".\U::safe_sql_string($p_data['merchant_id'])."',
							merchant_private_key = '".\U::safe_sql_string($p_data['merchant_private_key'])."',
							ptj_code = '".\U::safe_sql_string($p_data['ptj_code'])."',
							remarks = '".\U::safe_sql_string($p_data['remarks'])."',
							_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
							_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
						WHERE
							ag_id = '".\U::safe_sql_string($p_id_to_update_table)."'
						";
					$v_role_add = $this->co_db_root->execute_query($v_query);
					if ($v_role_add) {
						return TRUE;
					}
				}
			}
		}
	}
	/**
	 * Soft delete agency
	 *
	 * @access public
	 * @return
	 */
	public function agency_delete( $p_value ){
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "agency  
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( \E::get_session('usr_id') ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						ag_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/**
	 * Retrieve agency listing
	 *
	 * @access public
	 * @return
	 */
	public function agency_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name = "ag_id";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_location_name_code = $p_cond['location_name_code']; 
		$v_location_name_code_search = "";
		if( $v_location_name_code != '' ) {
			$v_location_name_code_search = " AND ( ag_name LIKE '%" . \U::safe_sql_string($v_location_name_code) . "%' OR ag_code LIKE '%" . \U::safe_sql_string($v_location_name_code) . "%')";
		}
		$v_agency_filter = $p_cond['agency_filter'];
		$v_agency_filter_search = "";
		if( $v_agency_filter != '' ) {
			$v_agency_filter_implode = "'" . implode ( "', '", \U::safe_sql_string($v_agency_filter)) . "'";
			$v_agency_filter_search = " AND ( ag_id IN(".$v_agency_filter_implode.") ) ";
		}
		$v_division_filter = $p_cond['division_filter'];
		$v_division_filter_search = "";
		if( $v_division_filter != '' ) {
			$v_division_filter_implode = "'" . implode ( "', '", \U::safe_sql_string($v_division_filter) ) . "'";
			$v_division_filter_search = " AND ( division IN(".$v_division_filter_implode.") ) ";
		}
		$v_status_filter = $p_cond['status_filter'];
		$v_status_filter_search = "";
		if( $v_status_filter != '' ) {
			$v_status_filter_implode = "'" . implode ( "', '", \U::safe_sql_string($v_status_filter)) . "'";
			$v_status_filter_search = " AND ( _rec_status IN(".$v_status_filter_implode.") ) ";
		}
 		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "agency 
				WHERE 
				 	_rec_status = \"SHOW\" 
				 	".$v_location_name_code_search." 
				 	".$v_agency_filter_search." 
				 	".$v_division_filter_search." 
				 	".$v_status_filter_search." 
				 	".$v_agency_condition."
				 	".$v_order_by."
				 	".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
}
?>