<?php
namespace moonlight\eticket;
class eticket_ticket_category_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Insert new ticket category
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_save($p_data) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				$v_query = "INSERT INTO
						" . $this->get_db_table_prefix() . "ticket_category
					SET
						code = '".\U::safe_sql_string($p_data['ticket_category_code'])."',
						name = '".\U::safe_sql_string($p_data['ticket_category_name'])."',
						description = '".\U::safe_sql_string($p_data['description'])."',
						agency = '".\U::safe_sql_string($p_data['agency'])."',
						category_type_key = '".\U::safe_sql_string($p_data['ticket_category_type'])."',
						category_type_value = '".\U::safe_sql_string($p_data['ticket_category_type_text'])."',
						location = '".\U::safe_sql_string($p_data['ticket_location'])."',
						remarks = '".\U::safe_sql_string($p_data['ticket_remarks'])."',
						_rec_status = '".\U::safe_sql_string($p_data['_rec_status'])."',
						_rec_created_by = '".\U::safe_sql_string($p_data['_rec_created_by'])."',
						_rec_created_on = '".\U::safe_sql_string($p_data['_rec_created_on'])."',
						_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
						_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
					";
				$v_role_add = $this->co_db_root->execute_query($v_query);
				if ($v_role_add) {
					return $v_role_id = $this->co_db_root->get_last_insert_id();
				}
			}
		}
	}
	/**
	 * Update ticket category
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_update($p_data, $p_id_to_update_table) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				if( isset($p_id_to_update_table) && $p_id_to_update_table != '' ) {
					$v_query = "UPDATE
						" . $this->get_db_table_prefix() . "ticket_category
					SET
						code = '".\U::safe_sql_string($p_data['ticket_category_code'])."',
						name = '".\U::safe_sql_string($p_data['ticket_category_name'])."',
						description = '".\U::safe_sql_string($p_data['description'])."',
						category_type_key = '".\U::safe_sql_string($p_data['ticket_category_type'])."',
						category_type_value = '".\U::safe_sql_string($p_data['ticket_category_type_text'])."',
						agency = '".\U::safe_sql_string($p_data['agency'])."',
						location = '".\U::safe_sql_string($p_data['ticket_location'])."',
						remarks = '".\U::safe_sql_string($p_data['ticket_remarks'])."',
						_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
						_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
					WHERE 
						id = '".$p_id_to_update_table."'
					";
					return $v_role_add = $this->co_db_root->execute_query($v_query);
				}
			}
		}
	}
	/**
	 * Retrieve ticket category by id
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_get_by_id($p_location_id) {
		if( isset($p_location_id) ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "ticket_category 
				 		WHERE
				 			id = '".\U::safe_sql_string($p_location_id)."'
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			if( isset($v_locations_data) ) {
				if( $v_locations_data != '' ) {
					return $v_locations_data[0];
				}
			}
		}
	}
	/**
	 * Soft del ticket category
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_delete( $p_value ){
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "ticket_category 
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( \E::get_session('usr_id') ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/**
	 * Retrieve ticket category listing with filters
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_search_by_user_name = $p_cond['search_by_user_name']; 
		$v_name_search = "";
		if( $v_search_by_user_name != '' ) {
			$v_name_search = " AND ( name LIKE '%" . \U::safe_sql_string($v_search_by_user_name) . "%')";
		}
		$v_category_filter = $p_cond['category_filter'];
		$v_category_search = "";
		if( $v_category_filter != '' ) {
			$v_category_search = " AND ( id IN('" . implode ( "', '", \U::safe_sql_string($v_category_filter)) . "') ) ";
		}
		$v_location_filter = $p_cond['location_filter'];
		$v_location_search = "";
		if( $v_location_filter != '' ) {
			$v_location_search = " AND ( location IN('" . implode ( "', '", \U::safe_sql_string($v_location_filter)) . "') ) ";
 		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "ticket_category 
				WHERE 
				 	_rec_status = \"SHOW\"
				 	".$v_name_search." 
				 	".$v_category_search." 
				 	".$v_location_search." 
				 	".$v_agency_condition." 
				 	".$v_order_by."
				 	".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve name,id from ticket category
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_get_all_categories(){	
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_col_name = "location";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_query = "SELECT
						name,id
					FROM
						" . $this->get_db_table_prefix() . "ticket_profile
					WHERE
				 		_rec_status = \"SHOW\" 
				 		".$v_agency_condition."
				 		".$v_location_condition."
			    ";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Get Ticket Category Name By Code Table Key
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_get_by_key($p_ticket_category_id=NULL){
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		if( isset($p_ticket_category_id) ) {
			$v_query = "SELECT
						*
					FROM
						" . $this->get_db_table_prefix() . "ticket_category
					WHERE
				 		_rec_status = \"SHOW\" 
				 	AND
				 		category_type_key = '".\U::safe_sql_string($p_ticket_category_id)."'
				 		".$v_agency_condition."
			    ";
			return $this->co_db_root->execute_query($v_query);
		}
	}
	/**
	 * Retrieve ticket Proifles by Ticket Categories
	 *
	 * @access public
	 * @return
	 */
	public function ticket_category_get_ticket_profiles($p_ticket_category_id){
		if( isset($p_ticket_category_id) ) {
			$v_query = "SELECT
						COUNT(*) as profile_total
					FROM
						" . $this->get_db_table_prefix() . "ticket_profile
					WHERE
				 		_rec_status = \"SHOW\" 
				 	AND
				 		category = '".\U::safe_sql_string($p_ticket_category_id)."'
			    ";
			$v_ticket_category_profiles_count = 0;
			$v_ticket_category_profiles = $this->co_db_root->execute_query($v_query);
			if( isset($v_ticket_category_profiles) ) {
				if( $v_ticket_category_profiles != '' ) {
					if( isset($v_ticket_category_profiles[0]['profile_total']) )  {
						$v_ticket_category_profiles_count = $v_ticket_category_profiles[0]['profile_total'];
					}
				}
			}
			return $v_ticket_category_profiles_count;
		}
	}
}
?>