<?php
namespace moonlight\eticket;
class eticket_ticket_template {
	private $co_db;
	public function __construct( $p_co_db ){
		$this->co_db = $p_co_db;
	}
	public function __destruct(){
		unset($this->co_db);
	}
	/**
	 * Insert new ticket template
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_save( $p_data ){
		return $this->co_db->ticket_template_save( $p_data );
	}
	/**
	 * Update ticket template
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_update( $p_data, $p_id_to_update_table ){
		return $this->co_db->ticket_profile_update( $p_data, $p_id_to_update_table );
	}
	/**
	 * Retrieve ticket template by id
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_get_by_id($p_template_id){
		return $this->co_db->ticket_template_get_by_id($p_template_id);
	}
	/**
	 * Retrieve all template data
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_get_all(){
		$v_template_name_ids = $this->co_db->ticket_template_get_all();
		$v_ticket_name_id = array();
		$v_ticket_name_id_implode = "";
		if( count($v_template_name_ids) > 0 ) {
			foreach ($v_template_name_ids as $key => $each_id) {
				array_push($v_ticket_name_id, $each_id['ticket_name']);
			}
			$v_ticket_name_id_implode = "'" . implode ( "', '", \U::safe_sql_string($v_ticket_name_id)) . "'";
		}
		$v_template_name_ids = $this->co_db->ticket_template_get_ticket_names($v_ticket_name_id_implode);
		return $v_template_name_ids;
	}
	/**
	 * Soft del Ticket Template by id
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_delete( $p_value ){
		$v_result = $this->co_db->ticket_template_delete( $p_value );
		return $v_result;
	}
	/**
	 * Retrieve ticket profile listing with filters
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		return $this->co_db->ticket_template_list_with_no_post($p_cond, $p_sort_by, $p_order_by, $p_page_start, $p_page_length);
	}
	/**
	 * Retrieve  ticket category listing
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_category_list(){
		return $this->co_db->ticket_profile_category_list();
	}
	/**
	 * Retrieve location listing
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_location_data($p_location_id){
		return $this->co_db->ticket_profile_location_data($p_location_id);
	}
	/**
	 * Retrieve ticket category by id
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_category_data($p_category_id){
		return $this->co_db->ticket_profile_category_data($p_category_id);
	}
	/**
	 * Update ticket template
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_edit( $p_data, $p_id_to_update_table ){
		return $this->co_db->ticket_template_edit( $p_data, $p_id_to_update_table );
	}
	/**
	 * Retrieve ticket Templates by Ticket Profile
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_get_ticket_templates($p_ticket_profile_id){
		return $this->co_db->ticket_template_get_ticket_templates($p_ticket_profile_id);
	}
	/**
	 * Retrieve Ticket Element Positions
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_element_positions_get_by_id($p_template_id){
		return $this->co_db->ticket_template_element_positions_get_by_id($p_template_id);
	}
	/**
	 * Retrieve Ticket Element Positions by TYPE
	 *
	 * @access public
	 * @return
	 */
	public function ticket_template_element_positions_get_by_element_type($p_template_id,$p_element_type){
		return $this->co_db->ticket_template_element_positions_get_by_element_type($p_template_id,$p_element_type);
	}
}
?>