<?php
namespace moonlight\eticket;
class eticket_user_role {
	private $co_db;
	public function __construct( $p_co_db ){
		$this->co_db = $p_co_db;
	}
	public function __destruct(){
		unset($this->co_db);
	}
    /**
	 * Get user role module list
	 *
	 * @access public
	 * @return
	 */
	public function user_role_module_list(  ){
		return $this->co_db->user_role_module_list(  );
	}
    /**
	 *Fetch user types list
	 *
	 * @access public
	 * @return
	 */
	public function user_role_user_type(  ){
		return $this->co_db->user_role_user_type(  );
	}
    /**
	 * Save role data
	 *
	 * @access public
	 * @return
	 */
	public function user_role_save(){
		return $this->co_db->user_role_save();
	}
	/**
	 * Update user role
	 *
	 * @access public
	 * @return
	 */
	public function user_role_update($p_id){
		return $this->co_db->user_role_update($p_id);
	}
	/**
	 * Retrieve user role listing with filters
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		return $this->co_db->user_role_list_with_no_post($p_cond, $p_sort_by, $p_order_by, $p_page_start, $p_page_length);
	}
	/**
	 * Retrieve user   listing according user roles
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_roles($p_cond, $p_order, $p_page_start, $p_page_length, $p_role_id){
		return $this->co_db->user_role_list_against_roles($p_cond, $p_order, $p_page_start, $p_page_length, $p_role_id);
	}
	/**
	 * Retrieve user  role user listing according to location
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_locations($p_cond, $p_order, $p_page_start, $p_page_length, $p_location_id){
		return $this->co_db->user_role_list_against_locations($p_cond, $p_order, $p_page_start, $p_page_length, $p_location_id);
	}
	/**
	 * Retrieve user  listing according to agency
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_agencies($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL, $p_location_id=NULL){
		return $this->co_db->user_role_list_against_agencies($p_cond, $p_sort_by, $p_order_by, $p_page_start, $p_page_length, $p_location_id);
	}
	/**
	 * Retrieve user  listing according locations
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_loactions($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL, $p_location_id=NULL){
		return $this->co_db->user_role_list_against_loactions($p_cond, $p_sort_by, $p_order_by, $p_page_start, $p_page_length, $p_location_id);
	}
	/**
	 * Retrieve user  role user listing according to locations
	 *
	 * @access public
	 * @return
	 */
	public function user_role_user_list_against_loactions($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL, $p_location_id=NULL){
		return $this->co_db->user_role_user_list_against_loactions($p_cond, $p_sort_by, $p_order_by, $p_page_start, $p_page_length, $p_location_id);
	}
	/**
	 * Retrieve user  role user listing according to locations
	 *
	 * @access public
	 * @return
	 */
	public function user_role_get($p_role_id){
		$v_roles_permissions = array();
		$v_roles_data = $this->co_db->user_role_get($p_role_id);
		$v_roles_permissions_data = $this->co_db->user_role_permissions($p_role_id);
		$v_roles_permissions["roles_data"] = $v_roles_data;
		$v_roles_permissions["roles_permissions"] = $v_roles_permissions_data;
		return $v_roles_permissions;
	}
	/**
	 * Soft del user role
	 *
	 * @access public
	 * @return
	 */
	public function user_role_delete( $p_value ){
		$v_result = $this->co_db->user_role_delete( $p_value );
		return $v_result;
	}	
	/**
	 * Retrieve user  role user listing according to locations
	 *
	 * @access public
	 * @return
	 */
	public function user_role_get_current_location_users(){
		$v_result = $this->co_db->user_role_get_current_location_users();
		return $v_result;
	}
	/**
	 * Chck role has any users or not
	 *
	 * @access public
	 * @return
	 */
	public function user_role_check_user_exists($p_role_id){
		$v_result = $this->co_db->user_role_check_user_exists($p_role_id);
		return $v_result;
	}
	/**
	 * GET ALL USERS Get all users against the same agency
	 *
	 * @access public
	 * @return
	 */
	public function user_role_user_list_against_agency(){
		return $this->co_db->user_role_user_list_against_agency();
	}
	/**
	 * Retrieve locations on agency_id
	 *
	 * @access public
	 * @return
	 */
	public function user_role_get_agency_roles($p_agency_id) {
		return $this->co_db->user_role_get_agency_roles($p_agency_id);
	}
}
?>