<?php
namespace moonlight\eticket;
class eticket_user_role_mysql {
	private $co_db_root;
	public function __call($name , $arguments) {
		$v_tmp_arr = explode("_" , $name);
		$v_call_obj = $v_tmp_arr[0];
		if (isset($this->co_db_root)) {
			return call_user_func_array(array(
				$this->co_db_root ,
				$name
			) , $arguments);
		}
	}
	public function __construct(&$p_co_db) {
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Get user role module list
	 *
	 * @access public
	 * @return
	 */
	public function user_role_module_list() {
		// QUERY - Module group lists
		$v_query = "SELECT *
				 FROM " . $this->get_db_table_prefix() . "module_group 
				 WHERE _rec_status = \"SHOW\" ";
		$v_module_group_lists = $this->co_db_root->execute_query($v_query);
		//fetch module list on the base of module group
		//make parent child relationship to display information on screen
		$v_lists = array();
		$v_items = array();
		if (isset($v_module_group_lists) && $v_module_group_lists !== NULL) {
			foreach ($v_module_group_lists as $v_list) {
				$v_items['name'] = $v_list['name'];
				$v_query = "SELECT *
				 FROM " . $this->get_db_table_prefix() . "module 
				 WHERE _rec_status = \"SHOW\" 
				 AND module_group_id=" . $v_list['id'] . " ";
				$v_items['items'] = $this->co_db_root->execute_query($v_query);
				$v_lists[] = $v_items;
			}
		}
		return $v_lists;
	}
	/**
	 *Fetch user types list
	 *
	 * @access public
	 * @return
	 */
	public function user_role_user_type(  ){
		$v_query = "SELECT
					*
				 FROM 
					" . $this->get_db_table_prefix() . "code_table 
				 WHERE
					_rec_status = \"SHOW\"
				 AND 
					for_module = \"role_type\"
				 ";
		$v_data = $this->co_db_root->execute_query($v_query);
		if( \E::get_session('logged_in_user_type') == 1 ) {
			unset($v_data[1]);
		}
		return $v_data;
	}
	/**
	 * Save role data
	 *
	 * @access public
	 * @return
	 */
	public function user_role_save() {
		$v_role_name = $_POST['role_name'];
		$v_role_description = $_POST['role_description'];
		$v_role_type = $_POST['role_type'];
		$v_role_status = $_POST['role_status'];
		$v_role_remarks = $_POST['role_remarks'];

		if( isset($_POST['agency_id']) && $_POST['agency_id'] != '' ) {
			$v_agency_id = $_POST['agency_id'];
		} else {
			$v_agency_id = \E::get_session("c_user_agency_id");
		}


		$v_usr_id = \E::get_session('usr_id');
		$v_current_datetime = \E::get('obj_curr_module')->__now();
		$v_query = "INSERT INTO
				" . $this->get_db_table_prefix() . "user_roles(
				name,
				description,
				agency_id,
				role_type,
				remarks,
				active_inactive_status,
				_rec_status,
				_rec_created_on,
				_rec_created_by,
				_rec_modified_on,
				_rec_modified_by
				)VALUE(
				\"" . \U::safe_sql_string($v_role_name) . "\",
				\"" . \U::safe_sql_string($v_role_description) . "\",
				\"" . \U::safe_sql_string($v_agency_id) . "\",
				\"" . \U::safe_sql_string($v_role_type) . "\",
				\"" . \U::safe_sql_string($v_role_remarks) . "\",
				\"" . \U::safe_sql_string($v_role_status) . "\",
				\"" . \U::safe_sql_string("SHOW") . "\",
				\"" . $v_current_datetime . "\",
				\"" . $v_usr_id . "\",
				\"" . $v_current_datetime . "\",
				\"" . $v_usr_id . "\" 
				)";
		$v_role_add = $this->co_db_root->execute_query($v_query);
		if ($v_role_add) {
			$v_role_id = $this->co_db_root->get_last_insert_id();
			$v_query = "SELECT *
				 FROM " . $this->get_db_table_prefix() . "module 
				 WHERE _rec_status = \"SHOW\" 
				   ";
			$v_module_lists = $this->co_db_root->execute_query($v_query);
			foreach ($v_module_lists as $v_list) {
				$v_module_view = 0;
				$v_module_edit = 0;
				$v_module_add = 0;
				$v_module_delete = 0;
				if (isset($_POST['module_view_' . $v_list['id']])) {
					$v_module_view = 1;
				}
				if (isset($_POST['module_edit_' . $v_list['id']])) {
					$v_module_edit = 1;
				}
				if (isset($_POST['module_add_' . $v_list['id']])) {
					$v_module_add = 1;
				}
				if (isset($_POST['module_delete_' . $v_list['id']])) {
					$v_module_delete = 1;
				}
				$v_query = "INSERT INTO
								" . $this->get_db_table_prefix() . "module_access(
								`role_id`,
								 module_id,
								 role_type,
								`view`,
								`edit`,
								`add`,
								`delete`,
								_rec_status,
								_rec_created_on,
								_rec_created_by,
								_rec_modified_on,
								_rec_modified_by
								)VALUE(
								\"" . \U::safe_sql_string($v_role_id) . "\",
								\"" . \U::safe_sql_string($v_list['id']) . "\",
								\"" . \U::safe_sql_string($v_role_type) . "\",
								\"" . \U::safe_sql_string($v_module_view) . "\",
								\"" . \U::safe_sql_string($v_module_edit) . "\",
								\"" . \U::safe_sql_string($v_module_add) . "\",
								\"" . \U::safe_sql_string($v_module_delete) . "\",
								 \"" . \U::safe_sql_string('SHOW') . "\",
								\"" . $v_current_datetime . "\",
								\"" . $v_usr_id . "\",
								\"" . $v_current_datetime . "\",
								\"" . $v_usr_id . "\" 
								)";
				$this->co_db_root->execute_query($v_query);
			}
		}
		return $v_role_id;
	}
	/**
	 * Retrieve user role listing with filters
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_login_type = \E::get_session('logged_in_user_type');
		$v_login_role_id_condition = "";
		$v_login_type_user = "";
		if( isset($v_login_type) && $v_login_type != 2 ) {
			$v_login_type_user = " AND role_type = 1 AND agency_id = '".\E::get_session("c_user_agency_id")."' ";
		}
		$v_usr_short_name = $p_cond['user_role'];
		$v_location_name_code_search = "";
		if( $v_usr_short_name != '' ) {
			$v_location_name_code_search = " AND ( name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%')";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "user_roles 
				WHERE 
					_rec_status = \"SHOW\"
					".$v_location_name_code_search." 
					".$v_login_role_id_condition."
					".$v_login_type_user."
					".$v_order_by."
					".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve user   listing according user roles
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_roles($p_cond=NULL, $p_order=NULL, $p_page_start=NULL, $p_page_length=NULL, $p_role_id=NULL){
		$v_usr_short_name = $p_cond['search_value'];
		$v_location_name_code_search = "";
		if( $v_usr_short_name != '' ) {
			$v_location_name_code_search = " AND ( usr_short_name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%' OR usr_full_name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%')";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( isset($p_order[0]['order_by']) && isset($p_order[0]['sort_by']) ) {
			if( $p_order[0]['order_by'] != '' && $p_order[0]['sort_by'] != '' ) {
				$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order[0]['order_by']) . " " . \U::safe_sql_string($p_order[0]['sort_by']) . " ";
			}
		}
		$v_query = "SELECT
						*
					FROM
						" . $this->get_db_table_prefix() . "user
					WHERE
						_rec_status = \"SHOW\" 
					AND
						role = '".$p_role_id."'
						".$v_location_name_code_search."
						".$v_order_by."
						".$v_limitation_data."
					";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve user  listing according locations
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_loactions( $p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL, $p_location_id=NULL ){
		$v_usr_short_name = $p_cond['search_value'];
		$v_location_name_code_search_main = "";
		if( $v_usr_short_name != '' ) {
			$v_location_name_code_search_main = " AND ( name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%' OR code LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%')";
		}
		$v_location_name_code = $p_location_id;
		$v_location_name_code_search = "";
		if( $v_location_name_code != '' ) {
			$v_location_name_code_search = " AND ( agency_id = '".\U::safe_sql_string($v_location_name_code)."' ) ";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "locations 
				WHERE 
					_rec_status = \"SHOW\"
					".$v_location_name_code_search."
					".$v_location_name_code_search_main."
					".$v_order_by."
					".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve user  listing according to agency
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_agencies( $p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL, $p_location_id=NULL ){
		if(!isset($p_cond['search_value'])){
			$v_usr_short_name = '';
		}else{
			$v_usr_short_name = $p_cond['search_value'];
		}
		$v_location_name_code_search_main = "";
		if( $v_usr_short_name != '' ) {
			$v_location_name_code_search_main = " AND ( usr_short_name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%' OR usr_full_name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%')";
		}
		$v_location_name_code = $p_location_id;
		$v_location_name_code_search = "";
		if( $v_location_name_code != '' ) {
			$v_location_name_code_search = " AND ( agency = '".\U::safe_sql_string($v_location_name_code)."' ) ";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "user 
				WHERE 
					_rec_status = \"SHOW\"
					".$v_location_name_code_search." 
					".$v_location_name_code_search_main." 
					".$v_order_by."
					".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve user  role user listing according to locations
	 *
	 * @access public
	 * @return
	 */
	public function user_role_user_list_against_loactions( $p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL, $p_location_id=NULL ){
		if(!isset($p_cond['search_value'])){
			$v_usr_short_name = '';
		}else{
			$v_usr_short_name = $p_cond['search_value'];
		}
		$v_location_name_code_search_main = "";
		if( $v_usr_short_name != '' ) {
			$v_location_name_code_search_main = " AND ( usr_short_name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%' OR usr_full_name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%')";
		}
		$v_location_name_code = $p_location_id;
		$v_location_name_code_search = "";
		if( $v_location_name_code != '' ) {
			$v_location_name_code_search = " AND ( location = '".\U::safe_sql_string($v_location_name_code)."' ) ";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_query = "SELECT
					*
					FROM
					" . $this->get_db_table_prefix() . "user 
					WHERE 
					_rec_status = \"SHOW\"
					".$v_location_name_code_search."
					".$v_location_name_code_search_main."
					".$v_order_by."
					".$v_limitation_data."
					";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve user  role user listing according to location
	 *
	 * @access public
	 * @return
	 */
	public function user_role_list_against_locations($p_cond, $p_order, $p_page_start, $p_page_length, $p_location_id){
		$v_query = "SELECT
						*
					FROM
						" . $this->get_db_table_prefix() . "user
					WHERE
						_rec_status = \"SHOW\" 
					AND
						location = '" . \U::safe_sql_string($p_location_id) . "'  
					";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve user  role listing
	 *
	 * @access public
	 * @return
	 */
	public function user_role_get($p_role_id){
		$v_query = "SELECT *
				 FROM " . $this->get_db_table_prefix() . "user_roles
				 WHERE id = '" . \U::safe_sql_string($p_role_id) . "' ";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve user  role permissions
	 *
	 * @access public
	 * @return
	 */
	public function user_role_permissions($p_role_id){
		$v_query = "SELECT *
				 FROM " . $this->get_db_table_prefix() . "module_access
				 WHERE role_id = '" . \U::safe_sql_string($p_role_id) . "' ";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Soft del user role
	 *
	 * @access public
	 * @return
	 */
	public function user_role_delete( $p_value ){
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "user_roles 
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( \E::get_session('usr_id') ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		$v_query1 = 	"UPDATE 
						" . $this->get_db_table_prefix() . "module_access 
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( \E::get_session('usr_id') ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						role_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result1 = $this->co_db_root->execute_query($v_query1);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/**
	 * Update user role
	 *
	 * @access public
	 * @return
	 */
	public function user_role_update($p_id) {
		$v_role_name = $_POST['role_name'];
		$v_p_id = $p_id;
		$v_role_description = $_POST['role_description'];
		$v_role_type = $_POST['role_type'];
		$v_role_status = $_POST['role_status'];
		$v_role_remarks = $_POST['role_remarks'];
		$v_usr_id = \E::get_session('usr_id');
		if( isset($_POST['agency_id']) && $_POST['agency_id'] != '' ) {
			$v_agency_id = $_POST['agency_id'];
		} else {
			$v_agency_id = \E::get_session("c_user_agency_id");
		}
		$v_current_datetime = \E::get('obj_curr_module')->__now();
		$v_query1 = "UPDATE 
						" . $this->get_db_table_prefix() . "user_roles
						SET
							name = \"" . \U::safe_sql_string($v_role_name) . "\",
							description = \"" . \U::safe_sql_string($v_role_description) . "\",
							role_type = \"" . \U::safe_sql_string($v_role_type) . "\",
							agency_id = \"" . \U::safe_sql_string($v_agency_id) . "\",
							remarks = \"" . \U::safe_sql_string($v_role_remarks) . "\",
							active_inactive_status = \"" . \U::safe_sql_string($v_role_status) . "\",
							_rec_modified_on = \"" . $v_current_datetime . "\",
							_rec_modified_by = \"" . $v_usr_id . "\" 
						WHERE
							id = '".$v_p_id."'
						";
		$v_role_update = $this->co_db_root->execute_query($v_query1);
		if ($v_role_update) {
			$v_query2 = "SELECT *
					 FROM " . $this->get_db_table_prefix() . "module 
					 WHERE _rec_status = \"SHOW\" 
					   ";
			$v_module_lists = $this->co_db_root->execute_query($v_query2);
			foreach ($v_module_lists as $v_list) {
				$v_module_view = 0;
				$v_module_edit = 0;
				$v_module_add = 0;
				$v_module_delete = 0;
				if (isset($_POST['module_view_' . $v_list['id']])) {
					$v_module_view = 1;
				}
				if (isset($_POST['module_edit_' . $v_list['id']])) {
					$v_module_edit = 1;
				}
				if (isset($_POST['module_add_' . $v_list['id']])) {
					$v_module_add = 1;
				}
				if (isset($_POST['module_delete_' . $v_list['id']])) {
					$v_module_delete = 1;
				}
				$v_query = "UPDATE
									" . $this->get_db_table_prefix() . "module_access
								SET
									`view` = \"" . \U::safe_sql_string($v_module_view) . "\",
									`edit` = \"" . \U::safe_sql_string($v_module_edit) . "\",
									`add` = \"" . \U::safe_sql_string($v_module_add) . "\",
									`delete` = \"" . \U::safe_sql_string($v_module_delete) . "\",
									_rec_status = \"" . \U::safe_sql_string('SHOW') . "\",
									_rec_created_on = \"" . $v_current_datetime . "\",
									_rec_created_by = \"" . $v_usr_id . "\",
									_rec_modified_on = \"" . $v_current_datetime . "\",
									_rec_modified_by = \"" . $v_usr_id . "\" 
								WHERE
									module_id = '".$v_list['id']."'
								AND 
									role_id = '".$v_p_id."'
								";
				$this->co_db_root->execute_query($v_query);
			}
		}
		return TRUE;
	}
	/**
	 * Retrieve user  role user listing according to locations
	 *
	 * @access public
	 * @return
	 */
	public function user_role_get_current_location_users(){
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_query = "SELECT
					*
					FROM
					" . $this->get_db_table_prefix() . "user 
					WHERE 
						_rec_status = \"SHOW\"
						".$v_agency_condition."
					AND 
						location != ''
					AND 
						active_inactive_status = 1
					";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Chck role has any users or not
	 *
	 * @access public
	 * @return
	 */
	public function user_role_check_user_exists($p_role_id){
		$v_query = "SELECT
						COUNT(*) as assigned_user_total
					FROM
						" . $this->get_db_table_prefix() . "user 
					WHERE 
						_rec_status = \"SHOW\"
					AND 
						role = '".\U::safe_sql_string($p_role_id)."'
					";
		$data = $this->co_db_root->execute_query($v_query);
		if( isset($data[0]['assigned_user_total']) && $data[0]['assigned_user_total'] > 0 ) {
			return $data[0]['assigned_user_total'];
		}
	}
	/**
	 * GET ALL USERS Get all users against the same agency
	 *
	 * @access public
	 * @return
	 */
	public function user_role_user_list_against_agency(){
		$v_query = "SELECT
					*
					FROM
					" . $this->get_db_table_prefix() . "user 
					WHERE 
						_rec_status = \"SHOW\"
					 AND
					 	agency = '".\E::get_session('c_user_agency_id')."'
					";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve locations on agency_id
	 *
	 * @access public
	 * @return
	 */
	public function user_role_get_agency_roles($p_agency_id){
		$v_agency_id_condition = "";
		if( isset($p_agency_id) && $p_agency_id != '' ) {
			$v_agency_id_condition = " AND agency_id = '".$p_agency_id."' ";
		} 

		$v_role_Type_condition = "";
		$v_logged_in_user_type = \E::get_session("logged_in_user_type");
		if( $v_logged_in_user_type == "2" ) {
			$v_role_Type_condition = "";
		} else {
			$v_agency_id_condition = " AND agency_id = '".\E::get_session("c_user_agency_id")."' ";
			$v_role_Type_condition = " AND role_type = 1 ";
		}
		

		$v_query = "SELECT
						*
			 		FROM 
			 			" . $this->get_db_table_prefix() . "user_roles 
			 		WHERE
			 			1=1
			 			".$v_agency_id_condition."
			 			".$v_role_Type_condition."
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		return $v_locations_data;
	}
}
?>