<?php
ini_set('display_errors', 0);

require_once dirname(__FILE__).'/lib/openpgp.php';
require_once dirname(__FILE__).'/lib/openpgp_crypt_rsa.php';
require_once dirname(__FILE__).'/lib/openpgp_crypt_symmetric.php';

function pgp_decrypt( $p_encrypted_data, $p_unarmor_encrypted_data = false ){
	
	$v_prv_key_file = \E::get( 'obj_curr_module' )->get_config()->get( 'gnupg_key_path/private_key' );	
	$v_passphrase = \E::get( 'obj_curr_module' )->get_config()->get( 'gpg_fingerprints/dec_passphrase' );
	
	$keyASCII = file_get_contents( $v_prv_key_file );
	$msgASCII = $p_encrypted_data;

	$keyEncrypted = OpenPGP_Message::parse( OpenPGP::unarmor( $keyASCII, 'PGP PRIVATE KEY BLOCK' ) );

	// Try each secret key packet
	foreach( $keyEncrypted as $p ) {
		if( !( $p instanceof OpenPGP_SecretKeyPacket ) ) continue;

		$key = OpenPGP_Crypt_Symmetric::decryptSecretKey( $v_passphrase, $p );
		
		if ( isset( $key ) ){
			$decryptor = new OpenPGP_Crypt_RSA( $key );
			
			if ( $p_unarmor_encrypted_data == false ){
				$decrypted = $decryptor->decrypt( $msgASCII );
			}else{
				$decrypted = $decryptor->decrypt( OpenPGP::unarmor($msgASCII, 'PGP MESSAGE') );
			}

			if ( isset( $decrypted ) ){

				if ( $decrypted->offsetGet( 0 ) !== null ){
					if ( $decrypted->offsetGet( 0 )->offsetGet( 0 ) !== null ){
						if ( isset( $decrypted->offsetGet( 0 )->offsetGet( 0 )->data ) && $decrypted->offsetGet( 0 )->offsetGet( 0 )->data != '' ){
							return $decrypted->offsetGet( 0 )->offsetGet( 0 )->data;
						}
					}
				}
			}

		}else{

			return false;

		}
		
	}
}


function pgp_encrypt( $p_plain_data ){
	
	$v_pub_key_file = \E::get( 'obj_curr_module' )->get_config()->get( 'gnupg_key_path/public_key' );	

	$key=OpenPGP_Message::parse(OpenPGP::unarmor(file_get_contents($v_pub_key_file),'PGP PUBLIC KEY BLOCK'));

	$data = new \OpenPGP_LiteralDataPacket($p_plain_data);

	$encrypted = \OpenPGP_Crypt_Symmetric::encrypt($key,new OpenPGP_Message(array($data)));


	if ( isset( $encrypted ) ){

		if ( $encrypted->offsetGet( 0 ) !== null ){
			if ( isset( $encrypted->offsetGet( 0 )->encrypted_data ) && $encrypted->offsetGet( 0 )->encrypted_data != '' ){
				return $encrypted->offsetGet( 0 )->encrypted_data;
			}
			// print_array( $encrypted->offsetGet( 0 )->encrypted_data );
			// if ( $encrypted->offsetGet( 0 )->offsetGet( 0 ) !== null ){
			// 	if ( isset( $encrypted->offsetGet( 0 )->offsetGet( 0 )->data ) && $encrypted->offsetGet( 0 )->offsetGet( 0 )->data != '' ){
			// 		return $encrypted->offsetGet( 0 )->offsetGet( 0 )->data;
			// 	}
			// }
		}
	}

	// return $encrypted;

}

?>